// startpt.cpp

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef unsigned char   Uchar;
typedef unsigned long   Ulong;
typedef unsigned short  Ushort;

struct TblRec
{
   short    cycle;
   char     key[5];
};

TblRec   tr;

char     hexKey[11];

//****************************************************************************
void
BinToHex(
   Uchar*   pBin,
   char*    pHex,
   short    inlen)
{
   char     zTmp[3] = "";
   int      ix;

	for (ix=0; ix < inlen; ix++)
   {
      itoa((Uchar)pBin[ix], zTmp, 16);
      if (zTmp[1] == 0)
      {
      	zTmp[1] = zTmp[0];
         zTmp[0] = '0';
      }
   	memcpy(pHex + (ix * 2), zTmp, 2);
   }

   pHex[(ix * 2)] = 0;
   return;
}
//****************************************************************************
int
main(
   int      argc,
   char*    argv[])
{
   FILE*    fpTbl;
   unsigned short clientno;
   unsigned short result   = 0;

   if (argc < 3)
   {
      fprintf(stderr, "Usage: startpt <client no> <filespec>\n");
      exit(-1);
   }

   clientno = atoi(argv[1]);
   if ((clientno > 0x4000u) || (clientno == 0))
   {
      fprintf(stderr, "Invalid client number (range 1-16384).\n");
      exit(-1);
   }

   fpTbl = fopen("starttbl.bin", "rb");
   if (!fpTbl)
   {
      fprintf(stderr, "Can't open starttbl.bin.\n");
      exit(-1);
   }

   clientno--;    // make zero based

   for (short ix = 0x2000; ix > 0; ix >>= 1)
   {
      if (clientno & ix)
      {
         unsigned short n = clientno ^ ix;   // turn off hi-bit
         n*=2; n++;
         unsigned short d = ix << 1;
         result = 0x4000;
         result /= d;
         result *= n;
         break;
      }
   }

   fseek(fpTbl, result * sizeof(tr), SEEK_SET);
   fread(&tr, sizeof(tr), 1, fpTbl);

   BinToHex(tr.key, hexKey, 5);

   printf("%d %s %s\n", tr.cycle, argv[2], hexKey);
   exit(0);
}
//****************************************************************************
//****************************************************************************

